# Installation

Start Arduino as root.

## Setup board
- In `Arduino/Preferences` add `https://raw.githubusercontent.com/espressif/arduino-esp32/gh-pages/package_esp32_index.json` to **Additional Boards Manager URLs**.
- In `Arduino/Tools/Boards/Boards Manager/` search for **esp32** and install it.
- In `Arduino/Tools/Boards/ESP Arduino/` select **ESP32S2 Dev Module**.
- In `Arduino/Tools/Port/` select **/dev/ttyUSB0**.



## Add libraries

### OSC
- Download **OSC** as `.ZIP` file from https://github.com/CNMAT/OSC.git
- In `Arduino/Sketch/Include Library/` click **Add .ZIP Library...**
- Choose the .zip file you downloaded from the repo.
- In `Arduino/Sketch/Include Library/` selecte **OSC**.

### MPU6050
- In `Arduino/Sketch/Include Library/Manage Libraries` serach for **MPU6050** and install it (*WARNING:* plain *MPU6050*, not any *xxxMPU5060xxx*)

## Python serial
In a terminal run:
`sudo pip install pyserial`



# BLE MIDI
- Arduino install library **BLE-MIDI 2.1.0** *WARNING: NOT THE LAST VERSION* 
- Check group name of the device: `ls -l /dev/ttyACM0` 
- Add user to tty group: `sudo usermod -aG GROUPNAME USERNAME`
- Load the code to the board
- Connect to it via Bluetooth
- Check MIDI reception
